﻿using System;

namespace Nimm
{
    class Game
    {
        PlayerBase PlayerMax { get; set; }
        PlayerBase PlayerMin { get; set; }
        Board board = new Board();

        public void Init(int numberInitialMatches)
        {
            board.Init(numberInitialMatches);
            if (HumanHasFirstMove())
            {
                PlayerMax = new PlayerHuman(board);
                PlayerMin = new PlayerComputer(board, -1);
            }
            else
            {
                PlayerMax = new PlayerComputer(board, 1);
                PlayerMin = new PlayerHuman(board);
            }
        }

        private bool HumanHasFirstMove()
        {
            Console.Write("Soll der Mensch den ersten Zug haben? (j/n)");
            string firstMove = Console.ReadLine();
            firstMove = firstMove.ToLower();
            return (firstMove == "j");
        }

        public void Run()
        {
            Move bestMove; 
            bool playerMaxHasToMove = true;
            string player;
            string objName;

            board.DrawBoard();
            do
            {
                if (playerMaxHasToMove) 
                {
                    bestMove = PlayerMax.SearchMove(playerMaxHasToMove);
                    player = PlayerMax.Player;
                }
                else
                {
                    bestMove = PlayerMin.SearchMove(playerMaxHasToMove);
                    player = PlayerMin.Player;
                }
                
                objName = bestMove.TakeNMatches > 1 ? "Streichhölzer" : "Streichholz";
                Console.WriteLine("Der {0} nimmt {1} {2}", player, bestMove.TakeNMatches, objName);
                board.Do(bestMove);
                board.DrawBoard();
                playerMaxHasToMove = !playerMaxHasToMove;
            } while (board.NumberOfMatches > 0);
            Console.WriteLine("Der {0} hat gewonnen.", player);
        }
    }
}
