﻿using System;
namespace Nimm
{
    class PlayerHuman : PlayerBase
    {
        public PlayerHuman(Board board)
            : base(board)
        {
            player = "Mensch";
        }

        override public Move SearchMove(bool playerMaxHasToMove)
        {
            return new Move(TakenNumberOfMatches());
        }

        private int TakenNumberOfMatches()
        {
            int takenNumberOfMatches;
            int takeMax;
            bool parsed;
            do
            {
                takeMax = board.NumberOfMatches < 3 ? board.NumberOfMatches : 3;
                Console.Write("Wie viele Streichhölzer sollen genommen werden? (1-{0})", takeMax);
                string nMatches = Console.ReadLine();
                parsed = Int32.TryParse(nMatches, out takenNumberOfMatches);
                if (!parsed)
                    Console.WriteLine("Int32.TryParse could not parse '{0}' to an int.\n", nMatches);
                else
                {
                    if (takenNumberOfMatches < 1 || takenNumberOfMatches > takeMax)
                    {
                        Console.WriteLine("Es dürfen/müssen 1 bis 3 Streichhölzer pro Zug entfernt weden.");
                        parsed = false;
                    }
                }
            } while (!parsed);
            return takenNumberOfMatches;
        }
    }
}
